function svi_grad_check()

D = 3;
N = 5;
ww = randn(D, 1);
 X = randn(N, D);
yy = rand(N, 1) < 0.5;

mm = randn(D,1);
LL = tril(randn(D));
Lsigma_w = randn();
params = {mm, LL, Lsigma_w};

hh = 1e-5;
neg_log_like_grad = @(w) logreg_negLlike(w, X, yy);
fn = @(p) svi_grad_cell(p, neg_log_like_grad);
params_fd = fd_grads(fn, hh, params)

[J, params_bar] = svi_grad_cell(params, neg_log_like_grad)

max_err = 0;
for i = 1:numel(params_fd)
    aa = params_fd{i};
    bb = params_bar{i};
    max_err = max(max_err, max(abs(aa(:) - bb(:))));
end
max_err


function [J, params_bar] = svi_grad_cell(params, neg_log_like_grad)
% Need to clamp random numbers to check derivatives
randn('state', 0);
rand('state', 0);
mm = params{1};
LL = params{2};
Lsigma_w = params{3};
[J, mm_bar, LL_bar, Lsigma_w_bar] = svi_grad(mm, LL, Lsigma_w, neg_log_like_grad);
params_bar = {mm_bar, LL_bar, Lsigma_w_bar};
